package TSEP1E01.TSEP1E01.controller;

import javax.annotation.PostConstruct;
import javax.enterprise.inject.Model;
import javax.enterprise.inject.Produces;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import TSEP1E01.TSEP1E01.model.Noticia;
import TSEP1E01.TSEP1E01.service.NoticiasServiciosLocal;;

@Model
public class NoticiaController {
	 @Inject
	    private FacesContext facesContext;

	    @Inject
	    private NoticiasServiciosLocal NoticiasServicios;

	    private Noticia newNoticia;
	    
	    @Produces
	    @Named
	    public Noticia getNewNoticia() {
	        return newNoticia;
	    }

	    public void register() throws Exception {
	        try {
	       
	        	NoticiasServicios.AgregarNoticia(newNoticia);
	            facesContext.addMessage(null,
	                    new FacesMessage(FacesMessage.SEVERITY_INFO, "Noticia Agregada!", "Yupiiii "));
	            initNewNoticia();
	        } catch (Exception e) {
	            String errorMessage = getRootErrorMessage(e);
	            FacesMessage m = new FacesMessage(FacesMessage.SEVERITY_ERROR, errorMessage, "No se puedo agregar la noticia");
	            facesContext.addMessage(null, m);
	        }
	    }

	    @PostConstruct
	    public void initNewNoticia() {
	    	newNoticia = new Noticia();
	    }

	    private String getRootErrorMessage(Exception e) {
	        // Default to general error message that registration failed.
	        String errorMessage = "No se puedo agregar la noticia. See server log for more information";
	        if (e == null) {
	            // This shouldn't happen, but return the default messages
	            return errorMessage;
	        }

	        // Start with the exception and recurse to find the root cause
	        Throwable t = e;
	        while (t != null) {
	            // Get the message from the Throwable class instance
	            errorMessage = t.getLocalizedMessage();
	            t = t.getCause();
	        }
	        // This is the root cause message
	        return errorMessage;
	    }
}
